<?php
/*
  Gestion des acces auw rubriques et articles par groupes d'utilisateurs
  Contrib de Coyote, alias JPK ou Jean-Pierre KUNTZ
  V0.1 - 16 juillet 2005
       version initiale avec gestion multilingue
  v0.2 - 02 aot 2005
       maj pour compatibilit avec MySQL 3.23
       la table jpk_auteurs_groupes devient jpk_groupes_auteurs
       correction affichage des titres de rubriques typo()
  v0.3 - 05 aot 2005
       ajout d'un bouton pour suppression d'un groupe
       transforme tous les mysql_query() en spip_query()
       Correction du test daccs, utilisation du login au lieu de lid_auteur
*/
$msg_text = '';
$alerte = 0;


// modifs clem pour utilisation d'un prfixe au noms de tables SPIP et/ou _jpk
include_once("inc_config-jpk.php3");

	
// le reste des modifs = modif des noms de tables remplacs par des variables de la forme $Tnom_table_SPIP_ou_jpk



// DETECTION DE L'EXTENSION (.php3 OU .php)
    $ext = "php";
    if (substr($_SERVER['PHP_SELF'],-1) == 3)  $ext = "php3";
    include ("inc.$ext"); 

/*     INITIALISATION DES TABLES DE JPK_GROUPES
*   dfinition et test existence des tables jpk_ 
*   + cration de la table si pas encore installe. 
*   PAS de DROP donc pas de risque de RAZ des contenus existants
*/

		$sql6881 = "SHOW TABLES LIKE '$Tjpk_groupes'";
		@$result6881 = spip_query($sql6881);
    if (! @$data6881 =  spip_num_rows($result6881) AND spip_num_rows($result6881) < 1) {
// cration de la table si elle n'existe pas
			 $sql_create1 = "CREATE TABLE $Tjpk_groupes (
                                id_groupe bigint(20) NOT NULL auto_increment,
                                nom varchar(30) NOT NULL default '',
                                description varchar(250) default NULL,
                                actif smallint(1) NOT NULL default '0',
                                proprio bigint(21) NOT NULL default '0',
                        PRIMARY KEY  (id_groupe),
                        UNIQUE KEY nom (nom) )";
			 @spip_query($sql_create1);
			 if (mysql_error() != '') {
			 			$msg_text .= "<br />".mysql_error()." "._T('accesgroupes:creation_table')." ".$Tjpk_groupes."\r\n";
						$alerte = 1;
			 }
			 else {
					 $msg_text .= "<br />"._T('accesgroupes:creation_table')." ".$Tjpk_groupes."\r\n";
			 }
		}
		
		$sql6882 = "SHOW TABLES LIKE '$Tjpk_groupes_auteurs'";
		$result6882 = spip_query($sql6882);
    if (! @$data6882 =  spip_num_rows($result6882) AND spip_num_rows($result6882) < 1) {
// cration de la table si elle n'existe pas
			 $sql_create2 = "CREATE TABLE $Tjpk_groupes_auteurs (
                            id_groupe bigint(21) NOT NULL default '0',
                            id_auteur bigint(21) NOT NULL default '0',
                            id_ss_groupe bigint(21) NOT NULL default '0',
                            sp_statut varchar(255) NOT NULL default '',
                            dde_acces smallint(1) NOT NULL default '1',
                            proprio bigint(21) NOT NULL default '0',
                         UNIQUE KEY id_grp (id_groupe,id_auteur,id_ss_groupe,sp_statut) )";
			 @spip_query($sql_create2);
			 if (mysql_error() != '') {
					 $msg_text .= "<br />".mysql_error()."  "._T('accesgroupes:creation_table')." ".$Tjpk_groupes_auteurs."\r\n";
					 $alerte = 1;
			 }
			 else {
					 $msg_text .= "<br />"._T('accesgroupes:creation_table')." ".$Tjpk_groupes_auteurs."\r\n";
			 }
		}
		
		
		$sql6883 = "SHOW TABLES LIKE '$Tjpk_groupes_acces'";
		$result6883 = spip_query($sql6883);
    if (! @$data6883 =  spip_num_rows($result6883) AND spip_num_rows($result6883) < 1) {
// cration de la table si elle n'existe pas
			 $sql_create3 ="CREATE TABLE $Tjpk_groupes_acces (
                            id_groupe bigint(21) NOT NULL default '0',
                            id_rubrique bigint(21) NOT NULL default '0',
                            id_article bigint(21) default NULL,
                            dtdb date default NULL,
                            dtfn date default NULL,
                            proprio bigint(21) NOT NULL default '0',
                          KEY id_groupe (id_groupe),
                          KEY id_rubrique (id_rubrique),
                          KEY id_article (id_article) )";
			@spip_query($sql_create3);
			if (mysql_error() != '' ) {
			 			$msg_text .= "<br />".mysql_error()." "._T('accesgroupes:creation_table')." ".$Tjpk_groupes_acces."\r\n";
						$alerte = 1;
			 }
			 else {
					 $msg_text .= "<br />"._T('accesgroupes:creation_table')." ".$Tjpk_groupes_acces."\r\n";
			 }
		}

		if ($msg_text != '') {
			 $tete_msg = '<div style="background: #ddd; border: solid 1px #000; padding: 10px; text-align: center;"><span style="color: '.($alerte != 1 ? '#6c3' : '#f00').'; text-align: center; font-weight: bold; font-size: 1.2em;">';
			 $tete_msg .= _T('accesgroupes:installation').($alerte != 1 ? _T('accesgroupes:install_ok') : _T('accesgroupes:install_pas_ok') ).'</span><br />';
			$queue_msg = '</div>';
			$msg_text = $tete_msg.$msg_text.$queue_msg;
		}
		
// FIN INITIALISATION TABLES JPK_GROUPES
		
		
//
// Les fonctions...
//
// DEB RECUP rubriques_edit.php3
// modif de la fonction trouve dans rubrique_edit.php3
// affichage des rubriques prives en rouge.
function enfant($leparent){
    global $id_parent;
    global $id_rubrique;
    global $connect_toutes_rubriques;
    global $i;
    global $couleur_claire, $spip_lang_left;
    global $browser_name, $browser_version;

// modifs clem pour utilisation d'un prfixe dans les noms de tables
		global $Tspip_rubriques, $Tspip_auteurs, $Tspip_auteurs_rubriques, $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes;
// fin modif

    $i++;
    $query="SELECT * FROM $Tspip_rubriques WHERE id_parent='$leparent' ORDER BY 0+titre,titre";
    $result=spip_query($query);

    while($row=spip_fetch_array($result)){
        $my_rubrique=$row['id_rubrique'];
        $titre=typo($row['titre']);
        $statut_rubrique = $row['statut'];
        $lang_rub = $row['lang'];
        $langue_choisie_rub = $row['langue_choisie'];
        $style = "";
        $espace = "";
        $prive = $row['prive'];

        if ($my_rubrique != $id_rubrique){

            if (eregi("mozilla", $browser_name)) {
                //$style .= "padding-$spip_lang_left: 16px; ";
                $style .= "margin-$spip_lang_left: ".($i*16)."px;";
            } else {
                for ($count = 0; $count <= $i; $count ++) $espace .= "&nbsp;&nbsp;&nbsp;&nbsp;";
            }

            if ($i > 3) $style .= "color: #666666;";
            if ($i > 4) $style .= "font-style: italic;";
            if ($i < 3) $style .= "font-weight:bold; ";
            if ($i==1) {
                $style .= "background-image: url(" . _DIR_IMG_PACK . 'secteur-12.gif);';
                $style .= "background-color: $couleur_claire;";
                $style .= "font-weight: bold;";
            }
            else if ($i==2) {
                $style .= "border-bottom: 1px solid $couleur_claire;";
                $style .= "font-weight: bold;";
            }
            else {
						
            }
         // affiche en rouge les rubriques prives
            $prive = 0;
            $query2 = "SELECT count(*) FROM $Tjpk_groupes_acces WHERE id_rubrique = $my_rubrique";
            $result2 = spip_query($query2);
            if ($row2 = spip_fetch_array($result2)){
            	 $prive = $row2['0'];
            }
            if ($prive>=1){
             	 $style .= "color:red;";
            }
            if ($statut_rubrique!='publie') $titre = "($titre)";
            if (lire_meta('multi_rubriques') == 'oui' AND $langue_choisie_rub == "oui") $titre = $titre." [".traduire_nom_langue($lang_rub)."]";

            $selec_rub = "selec_rub";
            if ($browser_name == "MSIE" AND floor($browser_version) == "5") $selec_rub = ""; // Bug de MSIE MacOs 9.0

            if (acces_rubrique($my_rubrique)) {
                echo "<option".mySel($my_rubrique,$id_parent)." class='$selec_rub' style=\"$style\">$espace".supprimer_tags($titre)."\n";
            }
            enfant($my_rubrique);
        }
    }
    $i=$i-1;
}
// FIN RECUP rubriques_edit.php3


function debug(){
         if(mysql_errno() > 0){
           echo mysql_errno().": ".mysql_error();
         }
}

function rub_reinit(){
    // modifs clem pour utilisation d'un prfixe dans les noms de tables
    		global $Tspip_rubriques, $Tspip_auteurs, $Tspip_auteurs_rubriques, $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes;
    
    
    // libre les rubriques qui n'ont plus de restriction
    // ok avec mysql 3.23
        $sql = "SELECT $Tspip_rubriques.* 
						    FROM $Tspip_rubriques
        				LEFT JOIN $Tjpk_groupes_acces
        				ON $Tspip_rubriques.id_rubrique = $Tjpk_groupes_acces.id_rubrique 
								AND $Tspip_rubriques.prive = 1
        				WHERE $Tjpk_groupes_acces.id_rubrique IS NULL";
        $result=spip_query($sql);
        debug($result);
        while ($row = spip_fetch_array($result)){
              $sql1 = "UPDATE $Tspip_rubriques SET prive=0 WHERE id_rubrique = \"".$row['id_rubrique']."\"";
              $result1=spip_query($sql1);
              debug($result1);
        }
}

    
// DEBUT DES FONCTIONS AJOUT - MODIFICATION - SUPPRESSION
(isset($_GET['groupe'])? $groupe = $_GET['groupe'] : $groupe = 0);
(isset($_POST['groupe'])? $groupe = $_POST['groupe'] : $groupe = $_GET['groupe']);

// modif clem pour traiter les admins restreints 
$id_util_restreint = 0;
if (est_admin_restreint() == TRUE) {
	 $id_util_restreint = trouve_id_utilisateur();
	 $Trub_restreint =  cree_Trub_admin ();
}	 

//$msg_text .= 'est_admin_restreint = '.est_admin_restreint().' $Trub_restreint = '.print_r($Trub_restreint).'<br>$id_util_restreint ='.$id_util_restreint.' trouve_id_utilisateur() = '.trouve_id_utilisateur();
//$msg_text .= '<br>$_REQUEST = '.print_r($_REQUEST);
//$msg_text . = '<br>$GLOBALS[auteur_session]= '.$GLOBALS['auteur_session'];
 // dsactive toutes les fcts de modifs du groupe si admin restreint + pas proprio !!! ATTENTION ce if est extra long !!!
if ($id_util_restreint == 0 OR ($id_util_restreint != 0 AND est_proprio($groupe) == TRUE)) {
        
    // AUTEUR ======================================================================
    // AUTEUR Ajout...
    if (isset($_POST['add_auteur'])){
    	$auteur = $_POST['auteur'];
    	$sql = "INSERT INTO $Tjpk_groupes_auteurs(id_groupe,id_auteur, dde_acces, proprio) VALUES($groupe, $auteur, 0, $id_util_restreint)";
      $result = spip_query($sql);
    }
    
    // AUTEUR Modif...
    if (isset($_GET['mod_auteur'])){
      $sql = "UPDATE $Tjpk_groupes_auteurs SET dde_acces = 0, proprio = $id_util_restreint WHERE id_groupe = $groupe AND id_auteur = $mod_auteur";
      $result = spip_query($sql);
    }
    
    // AUTEUR Suppression...
    if (isset($_GET['del_auteur'])){
      $sql = "DELETE FROM $Tjpk_groupes_auteurs WHERE id_groupe=$groupe AND id_auteur=$del_auteur";
      $result = spip_query($sql);
    }
    
    // SS-GROUPES ==================================================================
    // modif clem pour gestion des ss-groupes intgrs dans les groupes
    // SS-GROUPES Ajout...
    if (isset($_POST['add_ss_groupe'])){
      // vrification que le sous-groupe  crer n'est pas dans l'ascendance du groupe en cours 
    	// "never trust user" : en principe ce cas n'est pas possible mais un hack du POST est si vite arriv...
      	if (verifie_inclusions_groupe($_POST['add_ss_groupe'], $groupe) != FALSE) {
        	$sql = "INSERT INTO $Tjpk_groupes_auteurs(id_groupe,id_ss_groupe,dde_acces, proprio) VALUES($groupe,{$_POST['ss_groupe']}, 0, $id_util_restreint)";
          $result = spip_query($sql);
      	}
    		else {
    				 echo _T('accesgroupes:erreur_inclusion_recurrente');
    		}
    }
    
    // SS-GROUPES Modif...
    if (isset($_GET['mod_ss_groupe'])){
      $sql = "UPDATE $Tjpk_groupes_auteurs SET dde_acces = 0, proprio = $id_util_restreint WHERE id_groupe = $groupe AND id_ss_groupe = {$_GET['mod_ss_groupe']}";
      $result = spip_query($sql);
    }
    
    // SS-GROUPES Suppression...
    if (isset($_GET['del_ss_groupe'])){
      $sql = "DELETE FROM $Tjpk_groupes_auteurs WHERE id_groupe=$groupe AND id_ss_groupe = {$_GET['del_ss_groupe']}";
      $result = spip_query($sql);
    }
    
    // gestion des statuts intgrs dans les groupes
    // STATUTS Ajout...
    if (isset($_POST['add_statut'])){
        	$sp_statut = $_POST['sp_statut'];
    			$sql = "INSERT INTO $Tjpk_groupes_auteurs(id_groupe,sp_statut,dde_acces, proprio) VALUES ($groupe,'$sp_statut',0, $id_util_restreint)";
          $result = spip_query($sql);
    }
    
    // STATUTS Modif...
    if (isset($_GET['mod_statut'])){
      $mod_statut = $_GET['mod_statut'];
    	$sql = "UPDATE $Tjpk_groupes_auteurs SET dde_acces = 0, proprio = $id_util_restreint WHERE id_groupe = $groupe AND sp_statut = '$mod_statut'";
      $result = spip_query($sql);
    }
    
    // STATUTS Suppression...
    if (isset($_GET['del_statut'])){
      $del_statut = $_GET['del_statut'];
    	$sql = "DELETE FROM $Tjpk_groupes_auteurs WHERE id_groupe = $groupe AND sp_statut = '$del_statut'";
      $result = spip_query($sql);
    }
    

    
    // GROUPE ======================================================================
    // GROUPE Modification
    if (isset($_POST['mod_groupe'])){
      // modif clem pour viter les duplicatas de noms de groupes
				if (verifie_duplicata_groupes($_POST['nom']) == FALSE) {
					 $msg_text = '<h2 style="color: #f00;">'.$_POST['nom'].' : '._T('accesgroupes:duplicata_nom').'</h2>';
				}
				else {
      				if ($_POST['actif']==1){
              	 $actif = 1;
              }else{
              			$actif = 0;
              }
              $sql = "
              UPDATE $Tjpk_groupes
               SET nom=\"".$_POST['nom']."\",
                     description=\"".$_POST['description']."\",
                     actif=\"$actif\",
          					 proprio = $id_util_restreint
               WHERE id_groupe=".$_POST['groupe']."
              ";
              $result = spip_query($sql);
              debug($result);
				}
    }
} // fin du IF admin restreint + proprio
    // GROUPE Ajout
    if (isset($_POST['add_groupe'])){
      // modif clem pour viter les duplicatas de noms de groupes
				if (verifie_duplicata_groupes($_POST['nom']) == FALSE) {
					 $msg_text = '<h2 style="color: #f00;">'.$_POST['nom'].' : '._T('accesgroupes:duplicata_nom').'</h2>';
				}
				else {
              $sql = "
              INSERT INTO $Tjpk_groupes(nom,description,actif, proprio)
                   VALUES(\"".$_POST['nom']."\",\"".$_POST['description']."\",\"$actif\", $id_util_restreint)
              ";
              $result = spip_query($sql);
              debug($result);
              $groupe = mysql_insert_id();
				}
    }
// limitation admins restreints
if ($id_util_restreint == 0 OR ($id_util_restreint != 0 AND est_proprio($groupe) == TRUE)) {
    // GROUPE Suppression
    if (isset($_POST['del_groupe'])){
        $sql = "SELECT count(*) FROM $Tjpk_groupes_auteurs WHERE id_groupe = ".$_POST['groupe']."";
        $result = spip_query($sql);
        if (mysql_result($result,0) == 0){
            $sql = "SELECT count(*) FROM $Tjpk_groupes_acces WHERE id_groupe = ".$_POST['groupe']."";
            $result = spip_query($sql);
            if (mysql_result($result,0) == 0){
               $sql = "DELETE FROM $Tjpk_groupes
                        WHERE id_groupe = id_groupe=".$_POST['groupe']."";
               $result = spip_query($sql);
               debug($result);         
             }
      			 else{
             			$msg_text = "<h2>"._T('accesgroupes:sup_err_rubrique')."</h2>";
             }
        }
    		else{
        			$msg_text = "<h2>"._T('accesgroupes:sup_err_auteur')."</h2>";
        }
    }
    if (isset($_POST['del_groupe_all'])){
        $sql = "DELETE FROM $Tjpk_groupes_acces
                  WHERE id_groupe=".$_POST['groupe']."";
        $result = spip_query($sql);
        debug($result);
        $sql = "DELETE FROM $Tjpk_groupes_auteurs
                  WHERE id_groupe=".$_POST['groupe']."";
        $result = spip_query($sql);
        debug($result);         
        $sql = "DELETE FROM $Tjpk_groupes
                WHERE id_groupe=".$_POST['groupe']."";
        $result = spip_query($sql);
        debug($result);         
    }
}  // fin du IF admin restreint + proprio


// ACCES  ======================================================================
// ACCES AJOUT
if (isset($_POST['add_rub']) && $_POST['id_parent'] > 0){
  // si admin restreint, modif autorises si proprio de l'accs
	  $id_parent = $_POST['id_parent'];
		if ($id_admin_restreint == 0 OR  ($id_admin_restreint !== 0 AND est_proprio_acces($id_parent) == TRUE)) {
        $sql_verif = "SELECT count(*) AS RubAcces
          				 	  FROM $Tjpk_groupes_acces
         							WHERE id_groupe = \"".$_POST['groupe']."\" 
											AND id_rubrique = \"".$_POST['id_parent']."\" ";
        $result = spip_query($sql_verif);
        if ( mysql_result($result,0) <= 0){
           $sql = "INSERT INTO $Tjpk_groupes_acces(id_groupe,id_rubrique,id_article,dtdb,dtfn, proprio)
                   VALUES(\"".$_POST['groupe']."\", \"".$_POST['id_parent']."\", \"\",now(),now(), $id_util_restreint)";
           $result = spip_query($sql);
        }
				else{
         		 $msg_text = "<h2>"._T('accesgroupes:acces_double')."</h2>";
        }
		}
}
if (isset($_GET['del_rub'])){
 // si admin restreint, efface autoris si proprio de l'accs
  $id_parent_del = $_GET['del_rub'];
  if ($id_admin_restreint == 0 OR  ($id_admin_restreint !== 0 AND est_proprio_acces($del_rub) == TRUE)) {
      $sql = "DELETE FROM $Tjpk_groupes_acces WHERE id_groupe = $groupe AND id_rubrique = \"".$id_parent_del."\"";
      $result = spip_query($sql);
      debug($result);
	}
}
//rub_reinit();

// modif clem les fonctions ncessaires pour la gestions des ss-groupes et statuts inclus dans les groupes
// fct de vrification que le groupe_pere n'est pas inclu dans le groupe_fils ou l'un de ses ascendants (rcursivement)
// renvoie FALSE si groupe_pere ou l'un de ses ascendants contient groupe_fils 
function verifie_inclusions_groupe($id_groupe_fils, $id_groupe_pere) {
				 global $Tspip_rubriques, $Tspip_auteurs, $Tspip_auteurs_rubriques, $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes;
				 
				 $sql111 = "SELECT COUNT(*) AS inclusions FROM $Tjpk_groupes_auteurs WHERE id_groupe = $id_groupe_fils AND id_ss_groupe = $id_groupe_pere LIMIT 1";
				 $result111 = spip_query($sql111);
				 $row = spip_fetch_array($result111);
				 if ($row['inclusions'] > 0){
				  	 return FALSE;
				 }
			// le pre n'est pas inclu dans le fils => on teste toute l'ascendance du fils par rcurrence avant d'tre OK
				 else {
    				 $sql110 = "SELECT id_groupe FROM $Tjpk_groupes_auteurs WHERE id_ss_groupe = $id_groupe_pere";
    				 $result110 = spip_query($sql110);
    				 while ($row = spip_fetch_array($result110)) {
    				 			 $id_groupe_ec = $row["id_groupe"];
									 if (verifie_inclusions_groupe($id_groupe_fils, $id_groupe_ec) == FALSE) {
									 		return FALSE;
									 }
    				 }
				 }				 
			// pas d'inclusion d'un parent donc OK
				 return TRUE; 				 
}

// fct pour construire le tableau de la descendance d'un groupe (rcursivement)
function descendance_groupe($groupe_pere, $Tdescendance = array()) {
				 global $Tspip_rubriques, $Tspip_auteurs, $Tspip_auteurs_rubriques, $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes;
  			 $sql121 = "SELECT $Tjpk_groupes_auteurs.id_ss_groupe, $Tjpk_groupes.nom 
				 				 	  FROM $Tjpk_groupes_auteurs, $Tjpk_groupes
										WHERE $Tjpk_groupes_auteurs.id_groupe = $groupe_pere 
										AND $Tjpk_groupes_auteurs.id_ss_groupe = $Tjpk_groupes.id_groupe
										AND $Tjpk_groupes.actif = 1 
										AND $Tjpk_groupes_auteurs.id_ss_groupe != 0
										ORDER BY $Tjpk_groupes.nom";
  			 $result121 = spip_query($sql121);
				 while ($row = spip_fetch_array($result121)) {
				 			 $id_descendant_ec = $row["id_ss_groupe"];
							 $nom_descendant_ec = $row["nom"];
							 $Tdescendance[$groupe_pere][] = array('id' => $id_descendant_ec, 'nom' => $nom_descendant_ec);
							 $Tdescendance = descendance_groupe($id_descendant_ec, $Tdescendance);
				 }
				 return $Tdescendance;
}

// fct pour afficher le tableau $Tdesc de la descendance du groupe $id_grpe (rcursivement)
function affiche_descendance($id_grpe, $Tdesc, $a_afficher = "") {
				 global $Tspip_rubriques, $Tspip_auteurs, $Tspip_auteurs_rubriques, $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes;
				 if (is_array($Tdesc[$id_grpe]) AND count($Tdesc[$id_grpe]) > 0) {
				 		$a_afficher .= "<div style='margin-left: 10px; font-size: 10px; padding: 2px;'>";
						foreach ($Tdesc[$id_grpe] as $a => $Td) {
									 $a_afficher .= "<img src='img_pack/sous-groupe.png' alt='|_' style='vertical-align:top;'>";
        					 $a_afficher .= "<img src='img_pack/groupe-12.png' alt='|_' style='vertical-align:top;'> <a href=\"$PHP_SELF?groupe=".$Td['id']."\">".$Td['nom']."</a><br />";
									 $a_afficher = affiche_descendance($Td['id'], $Tdesc, $a_afficher);
    			  }
				 		$a_afficher .= "</div>";
				 }
				 return $a_afficher;
}

// fct pour crer le tableau des rubriques gres par les groupes
function affiche_groupes_rubriques() {
				 global $Tspip_rubriques, $Tspip_auteurs, $Tspip_auteurs_rubriques, $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes;
         $a_afficher =  "<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 WIDTH='100%' class='arial2' style='border: 1px solid #aaaaaa;'>\n";
         $a_afficher .= "<tr><th colspan=\"2\">"._T('accesgroupes:groupes_rubriques')."</th></tr>";
      	 $sql301 = "SELECT $Tjpk_groupes_auteurs.id_groupe, $Tjpk_groupes.nom
      	 				 	  FROM $Tjpk_groupes_auteurs, $Tjpk_groupes
      							WHERE $Tjpk_groupes_auteurs.id_groupe = $Tjpk_groupes.id_groupe
      							GROUP BY id_groupe";
      	 $result301 = spip_query($sql301);
      	 while ($row301 = spip_fetch_array($result301)) {
      	 			 $id_grpe_ec = $row301['id_groupe'];
      				 $nom_grpe_ec = $row301['nom'];
               $a_afficher .= "<tr style='background-color: #eeeeee;'>";
               $a_afficher .= "<td class='verdana11' style='border-top: 1px solid #cccccc; width: 14px; vertical-align:top;'>";
      				 if (est_admin_restreint() == TRUE AND est_proprio($id_grpe_ec) == TRUE) {
							 		$a_afficher .= "<img src='img_pack/admin-12.gif' alt='|_' style='vertical-align:top;'>";
							 }
							 $a_afficher .= "<img src='img_pack/groupe-12.png' alt='|_' style='vertical-align:top;'></td>";
      				 $a_afficher .= "<td style='border-top: 1px solid #cccccc;'><a href=\"$PHP_SELF?groupe=".$id_grpe_ec."\">".$nom_grpe_ec."</a><br />";
      				 $a_afficher .= "<div style='margin-left: 20px; font-size: 10px; padding: 2px;'>";
      				 $sql302 = "SELECT $Tspip_rubriques.titre, $Tspip_rubriques.id_rubrique
      				 				 	  FROM $Tspip_rubriques, $Tjpk_groupes_acces
      										WHERE $Tjpk_groupes_acces.id_groupe = $id_grpe_ec
      										AND $Tjpk_groupes_acces.id_rubrique = $Tspip_rubriques.id_rubrique";
      				 if ($result302 = spip_query($sql302)) {
      				 		while ($row302 = spip_fetch_array($result302)) {
      				 					$id_rub_ec = $row302['id_rubrique'];
      									$nom_rub_ec = $row302['titre'];
      									$a_afficher .= "<img src='img_pack/sous-groupe.png' alt='|_' style='vertical-align:top;'>";
      									$a_afficher .= " <a href=\"naviguer.php3?id_rubrique=".$id_rub_ec."\"><img src='img_pack/rubrique-12.gif' alt='|_' style='vertical-align:top; border: 0px;'>".$nom_rub_ec."</a><br />";
      				 		}
      				 }
      				 $a_afficher .= "</div>\r\n</td>";
               $a_afficher .= "</tr>";
      	 }
         $a_afficher .= "</table>";
				 return $a_afficher;
}

// fct pour crer le tableau des rubriques d'un admin restreint
function cree_Trub_admin () {
				  global $Tspip_rubriques, $Tspip_auteurs, $Tspip_auteurs_rubriques, $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes;
          
					$id_utilisateur = trouve_id_utilisateur();
					$sql501= "SELECT  id_rubrique
									 	FROM $Tspip_auteurs_rubriques
										WHERE id_auteur = '$id_utilisateur'";
					$result501 = spip_query($sql501);
					$Trubriques_autorises = array();
					while ($row501 = spip_fetch_array($result501)) {
								$Trubriques_autorises[] = $row501['id_rubrique'];
					}
					return $Trubriques_autorises;
}

// fct pour trouver l'id de l'utilisateur en cours
function trouve_id_utilisateur() {
				  global $Tspip_rubriques, $Tspip_auteurs, $Tspip_auteurs_rubriques, $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes;
					
				  $login_utilisateur = $GLOBALS['auteur_session']['login'];

					$sql502 = "SELECT id_auteur FROM $Tspip_auteurs WHERE login = '$login_utilisateur' LIMIT 1";
					$result502 = spip_query($sql502);
					$row502 = spip_fetch_array($result502);
					$id_utilisateur = $row502['id_auteur'];
					return $id_utilisateur;				 
}

// fct pour dterminer si l'utilisateur en cours est admin restreint
function est_admin_restreint() {
				 $Trub_restreint = cree_Trub_admin ();
				 if (count($Trub_restreint) > 0) {
				 		return TRUE;
				 }
				 else {
				 			return $Trub_restreint;
				 }
}

// fct pour dterminer si l'utilisateur est proprio du groupe en cours (donc peut le modifier)
function est_proprio($id_groupe) {
				 global $Tspip_rubriques, $Tspip_auteurs, $Tspip_auteurs_rubriques, $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes;
				 $sql505 = "SELECT proprio FROM $Tjpk_groupes WHERE id_groupe = $id_groupe LIMIT 1";
				 $result505 = spip_query($sql505);
				 $row505 = spip_fetch_array($result505);
				 $id_proprio = $row505['proprio'];
				 if ($id_proprio == trouve_id_utilisateur()) {
				 		return TRUE;
				 }
				 else {
				 			return FALSE;
				 }
}

// fct pour dterminer si l'utilisateur est proprio de l'accs sur une rubrique
function est_proprio_acces($id_rubrique) {
				 global $Tspip_rubriques, $Tspip_auteurs, $Tspip_auteurs_rubriques, $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes;
				 $sql506 = "SELECT proprio FROM $Tjpk_groupes_acces WHERE id_rubrique = $id_rubrique LIMIT 1";
				 $result506 = spip_query($sql506);
				 $row506 = spip_fetch_array($result506);
				 $id_proprio_acces = $row506['proprio'];
				 if ($id_proprio_acces == trouve_id_utilisateur()) {
				 		return TRUE;
				 }
				 else {
				 			return FALSE;
				 }
}

// fct pour dterminer le statut d'un utilisateur
function trouve_statut($id_util) {
				 global $Tspip_rubriques, $Tspip_auteurs, $Tspip_auteurs_rubriques, $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes;
				 $sql506 = "SELECT statut FROM $Tspip_auteurs WHERE id_auteur = $id_util LIMIT 1";
				 $result506 = spip_query($sql506);
				 $row506 = spip_fetch_array($result506);
				 return $row506['statut'];
}

// fct pour traiter les noms de groupes en doublons retourne FALSE si le nom existe dja
function verifie_duplicata_groupes($nom_at) {
				 global $Tspip_rubriques, $Tspip_auteurs, $Tspip_auteurs_rubriques, $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes;
				 $sql507 = "SELECT nom FROM $Tjpk_groupes";
				 if ($result507 = spip_query($sql507)) {
    				 while ($row507 = spip_fetch_array($result507)) {
    				 			 if ($row507['nom'] == $nom_at) {
    							 		return FALSE;
    							 }
    				 }
				 }
				 return TRUE;
}

// fin modif clem



// DEBUT PAGE ==================================================================
debut_page(_T('accesgroupes:module_titre'));
echo "<STYLE type='text/css'>
<!--
-->
</STYLE>";

// SECURITE 
if ($connect_statut != "0minirezo") {
    echo "<H3><FONT COLOR = red>"._T('avis_non_acces_page')."</FONT></H3>";
    fin_page();
    exit;
}
// =============================================================================
// GAUCHE
// =============================================================================
debut_gauche();
debut_boite_info();
			echo "<b>"._T('accesgroupes:module_titre')."</b>"._T('accesgroupes:module_info');
			if (isset($msg) AND $msg != '') {
				 echo $msg;
			}
fin_boite_info();


$sql = "SELECT * FROM $Tjpk_groupes";
$result = spip_query($sql);

debut_cadre_relief('groupe-24.png');
echo "<form action=\"$PHP_SELF\" name=\"frm_groupe\" method=\"post\">";
echo "<br />"._T('accesgroupes:select').": <select name=\"groupe\" size=\"1\" onchange='submit()';>";
echo "<option value=\"0\">"._T('accesgroupes:select_vide')."</option>";
 while ($row = spip_fetch_array($result)){
 			 echo "<option value=".$row['id_groupe'].($groupe== $row['id_groupe'] ? ' selected':'').">".typo($row['nom'])."</option>";
 }
echo "</select>";

$sql_grp  = "SELECT * FROM $Tjpk_groupes WHERE id_groupe=\"$groupe\"";
$result_grp = spip_query($sql_grp );
if ($row = spip_fetch_array($result_grp))
   $nom = $row['nom'];
   $desc = $row['description'];
   $actif = $row['actif'];

echo "\n<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=3 WIDTH=100% BACKGROUND=''><TR><TD class='serif2'>";
echo bouton_block_invisible('groupeinfo');
echo "$desc";
echo "</TD></TR></TABLE>\n";

echo debut_block_invisible('groupeinfo');
echo "\n<table width=\"100%\">";
echo "\n<tr><td valign=\"top\">"._T('accesgroupes:nom')."</td>
          <td><input type=\"text\" name=\"nom\" value=\"$nom\" size=\"18\" /></td>
      </tr>";
echo "\n<tr><td valign=\"top\">"._T('accesgroupes:description')."</td>
          <td><textarea name=\"description\" rows=\"4\" cols=\"15\">$desc</textarea></td>
      </tr>";
echo "\n<tr><td valign=\"top\">"._T('accesgroupes:actif')."</td>
          <td>";
echo "   <input type=\"checkbox\" name=\"actif\" value=\"1\" ".(($actif==1)? 'checked ':'')."/>";
echo "	  </td>
		  </tr>\n
		  <tr>";
echo "<th>
      <input type=\"hidden\" name=\"id_groupe\" value=\"$groupe\" />
      <input type=\"submit\" name=\"add_groupe\" value=\""._T('accesgroupes:creer')."\" CLASS='fondo' STYLE='font-size:10px' />
     </th>";

    if ($groupe > 0 ){
// admins restreints interdits si pas proprios			
if ($id_util_restreint == 0 OR ($id_util_restreint != 0 AND est_proprio($groupe) == TRUE)) {
    	 echo "<th><input type=\"submit\" name=\"mod_groupe\" value=\""._T('accesgroupes:modifier')."\" CLASS='fondo' STYLE='font-size:10px' />";
} // fin limitations admins restrients
    }else{
    			echo "<th>&nbsp;";
    }
    if ($groupe > 0 && $actif==0){
// admins restreints interdits si pas proprios			
if ($id_util_restreint == 0 OR ($id_util_restreint != 0 AND est_proprio($groupe) == TRUE)) {
      if (isset($_POST['del_groupe'])){
        echo "</th></tr><tr><th colspan=\"2\"><input type=\"submit\" name=\"del_groupe_all\" value=\""._T('accesgroupes:supprimer_tout')."\" CLASS='fondo' STYLE='font-size:10px' />";
      }else{
        echo "<input type=\"submit\" name=\"del_groupe\" value=\""._T('accesgroupes:supprimer')."\" CLASS='fondo' STYLE='font-size:10px' />";
      }
} // fin limitations admins restrients
    }
    


echo "</th></tr>";
echo "\n</table>";
echo fin_block();
fin_cadre_relief();
echo "</form>";


// modif clem pour afficher la rpartition des rubriques par groupes
if ($groupe != 0){
	 debut_cadre_relief('rubrique-24.gif');
	 echo affiche_groupes_rubriques();	 
	 fin_cadre_relief();
}

// modif clem pour afficher l'arborescence des groupes

debut_raccourcis();
					
      echo "<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 WIDTH='100%' class='arial2' style='border: 1px solid #aaaaaa;'>\n";
      echo "<tr style='background-color: #fff;'><th colspan=\"2\">"._T('accesgroupes:arborescence_groupes')."</th><th colspan=\"2\">&nbsp;</th></tr>";

			$sql102 = "SELECT $Tjpk_groupes_auteurs.id_groupe, $Tjpk_groupes_auteurs.dde_acces, $Tjpk_groupes.nom 
								 FROM $Tjpk_groupes_auteurs, $Tjpk_groupes
								 WHERE $Tjpk_groupes.actif = 1 
								 AND $Tjpk_groupes_auteurs.id_groupe = $Tjpk_groupes.id_groupe 
								 GROUP BY $Tjpk_groupes.nom";
			$result102 = spip_query($sql102);
      while ($row = spip_fetch_array($result102)){
      			 $id_ec = $row['id_groupe'];
      			 $nom_ec = $row['nom'];
      			 echo "<tr style='background-color: #eeeeee;'>";
             echo "<td class='verdana11' style='border-top: 1px solid #cccccc; width: 14px; vertical-align:top;'>";
						 echo "<img src='img_pack/groupe-12.png' alt='|_' style='vertical-align:top;'></td>";
             echo "<td style='border-top: 1px solid #cccccc;'><a href=\"$PHP_SELF?groupe=".$id_ec."\">".$nom_ec."</a><br />";
      			 echo affiche_descendance($id_ec, descendance_groupe($id_ec));
      			 echo "</td>";
             echo "<td style='border-top: 1px solid #cccccc; text-align : right; padding-right: 20px; vertical-align: top; position: relative; top: 0px;'>";
		  // supprimer rapide pour les admins pas restreints
				if ($id_util_restreint == 0 AND $groupe != 0) {
						 echo "<a href=\"".$PHP_SELF."?del_ss_groupe=".$row['id_ss_groupe']."&groupe=".$groupe."\">". http_img_pack('croix-rouge.gif', "X", "width='7' height='7' border='0'")."</a>";
				}
				else {
						 echo "&nbsp;";
				}					 
						 echo "</td>";
             echo "</tr>";
      }




      echo "</table>";
	
fin_raccourcis();


// fin modif arborescence

// =============================================================================
// DROITE
// =============================================================================
debut_droite();
//ok avec mysql 3.23
$sql1 = "SELECT $Tspip_auteurs.*
  			 FROM $Tspip_auteurs
				 LEFT JOIN $Tjpk_groupes_auteurs
				 ON $Tspip_auteurs.id_auteur =  $Tjpk_groupes_auteurs.id_auteur 
				 AND $Tjpk_groupes_auteurs.id_groupe = \"$groupe\"
	 			 WHERE $Tjpk_groupes_auteurs.id_auteur IS NULL
	 			 ";
$sql1 .= " AND statut!='5poubelle' 
				 	 AND statut!='nouveau' 
					 ORDER BY $Tspip_auteurs.statut, $Tspip_auteurs.nom, $Tspip_auteurs.id_auteur";
$result1 = spip_query($sql1);
if (mysql_errno() > 0) echo mysql_errno().": ".mysql_error();



if (mysql_errno() > 0) echo mysql_errno().": ".mysql_error();

if ($groupe <= 0){
	 
// modif clem pour affichage des groupes existants et des rubriques qu'ils contrlent
gros_titre(_T('accesgroupes:titre_groupes'));
echo "<br />";
debut_cadre_trait_couleur("auteur-24.gif", false, "", _T('accesgroupes:membres'));
      echo "$msg_text";
      gros_titre(_T('accesgroupes:choisir'));
fin_cadre_trait_couleur();
echo "<br />";

debut_cadre_trait_couleur("rubrique-24.gif", false, "", _T('accesgroupes:organisation'));

	 echo affiche_groupes_rubriques();

fin_cadre_trait_couleur();

// fin modif

}
else {
      gros_titre(_T('accesgroupes:titre_page_groupe').' : '.$nom.' (n&deg; '.$groupe.')');
      echo "<br />";
debut_cadre_trait_couleur("auteur-24.gif", false, "", _T('accesgroupes:auteurs')._T('accesgroupes:du_groupe'));

      echo "$msg_text";
			
// admins restreints interdits si pas proprios			
   if ($id_util_restreint == 0 OR ($id_util_restreint != 0 AND est_proprio($groupe) == TRUE)) {
debut_cadre_couleur();
		  echo "<form action=\"$PHP_SELF\" name=\"frm_auteur\" method=\"post\">";
			echo "<input type=\"hidden\" name=\"groupe\" value=\"$groupe\" />";
      echo _T('accesgroupes:ajouter_auteur');
			echo "<SELECT NAME='auteur' SIZE='1' STYLE='width:150px;' CLASS='fondl'>";
      $group = false;
      $group2 = false;

      while ($row = spip_fetch_array($result1)) {
            $id_auteur = $row["id_auteur"];
            $nom = $row["nom"];
            $email = $row["email"];
            $statut = $row["statut"];
						
            $statut=str_replace("0minirezo", _T('info_administrateurs'), $statut);
            $statut=str_replace("1comite", _T('info_redacteurs'), $statut);
            $statut=str_replace("6visiteur", _T('info_visiteurs'), $statut);
  
            $premiere = strtoupper(substr(trim($nom), 0, 1));
  
            if ($connect_statut != '0minirezo')
                if ($p = strpos($email, '@'))
                    $email = substr($email, 0, $p).'@...';
            if ($email)
                $email = " ($email)";
  
            if ($statut != $statut_old) {
                echo "\n<OPTION VALUE=\"x\"> </OPTION>";
                echo "\n<OPTION VALUE=\"x\" style='background-color: $couleur_claire;'> $statut</OPTION>";
            }
  
            if ($premiere != $premiere_old AND ($statut != _T('info_administrateurs') OR !$premiere_old)) {
                echo "\n<OPTION VALUE=\"x\">";
            }
  
            $texte_option = supprimer_tags(couper(typo("$nom$email"), 40));
            echo "\n<OPTION VALUE=\"$id_auteur\">&nbsp;&nbsp;&nbsp;&nbsp;$texte_option</OPTION>";
            $statut_old = $statut;
            $premiere_old = $premiere;
      }

      echo "</SELECT>";
			echo "<input type=\"submit\" name=\"add_auteur\" value=\""._T('accesgroupes:ajouter')."\"  CLASS='fondo'/>";
fin_cadre_couleur();		
   } // fin restriction admin restreint
      echo "<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 WIDTH='100%' class='arial2' style='border: 1px solid #aaaaaa;'>\n";
      echo "<tr><th colspan=\"2\">"._T('accesgroupes:auteurs_groupe')."</th><th colspan=\"2\">&nbsp;</th></tr>";
      $sql2 = "SELECT $Tspip_auteurs.id_auteur, $Tspip_auteurs.nom, $Tspip_auteurs.statut, $Tjpk_groupes_auteurs.dde_acces
        			 FROM $Tjpk_groupes_auteurs, $Tspip_auteurs
       				 WHERE $Tjpk_groupes_auteurs.id_auteur = $Tspip_auteurs.id_auteur 
      				 AND $Tjpk_groupes_auteurs.id_groupe = \"$groupe\"";
      $result2 = spip_query($sql2);
      while ($row = spip_fetch_array($result2)){
           echo "<tr style='background-color: #eeeeee;'>";
           echo "<td class='verdana11' style='border-top: 1px solid #cccccc; width: 14px; vertical-align:top;'>";
  				 $statut_util_ec = trouve_statut($row['id_auteur']);
					 $statut_util_ec == '0minirezo' ?  $ico_statut = 'admin-12.gif' : ($statut_util_ec == '1comite' ? $ico_statut = 'redac-12.gif' : $ico_statut = 'visit-12.gif');
					 echo "<img src='img_pack/".$ico_statut."' alt='|_' style='vertical-align:top;'></td>";
           echo "<td style='border-top: 1px solid #cccccc;'><a href=\"auteurs_edit.php3?id_auteur=".$row['id_auteur']."\">".$row['nom']."</a></td>";
           echo "<td style='border-top: 1px solid #cccccc; text-align : right; padding-right: 20px;'>";
			 if ($id_util_restreint == 0 OR ($id_util_restreint != 0 AND est_proprio($groupe) == TRUE)) {
					 echo "<a href=\"".$PHP_SELF."?del_auteur=".$row['id_auteur']."&groupe=$groupe\"> "._T('lien_retirer_auteur')." &nbsp;  ".http_img_pack('croix-rouge.gif', "X", "width='7' height='7' border='0' align='middle'")."</a>";
           echo ($row['dde_acces']==1) ? "&nbsp;|&nbsp;<a href=\"".$PHP_SELF."?mod_auteur=".$row['id_auteur']."&groupe=".$groupe."\"> "._T('accesgroupes:accepter')."</a>" : "";
				}
				else {
						 echo $row['id_auteur'];
				}
					 echo "</td>";
           echo "<td style='border-top: 1px solid #cccccc;'><a href=\"mailto:$email\"></a></td>";
           echo "</tr>";
      }
      echo "</table>";
fin_cadre_trait_couleur();


// modif clem pour pouvoir inclure/grer des ss-groupes ou des statuts dans les groupes
// dbut des sous-groupes
      echo "<br />";
debut_cadre_trait_couleur("groupe-24.png", false, "", _T('accesgroupes:ss_groupes')._T('accesgroupes:du_groupe'));

// admins restreints interdits si pas proprios
   if ($id_util_restreint == 0 OR ($id_util_restreint != 0 AND est_proprio($groupe) == TRUE)) {
debut_cadre_couleur();
			echo _T('accesgroupes:ajouter_ss_groupe');
      echo "\r\n<SELECT NAME='ss_groupe' SIZE='1' STYLE='width:150px;' CLASS='fondl'>\r\n";
			
			$sql101 = "SELECT id_groupe, nom FROM $Tjpk_groupes WHERE id_groupe != $groupe AND actif = 1 ORDER BY nom";
			$result101 = spip_query($sql101);
			

      echo "\n<OPTION VALUE=\"x\"> </OPTION>\r\n";
      while ($row = spip_fetch_array($result101)) {
            $id_ss_groupe = $row["id_groupe"];
            $nom_ss_groupe = $row["nom"];
  			// ne pas afficher les groupes dja inclus dans le groupe en cours (et leurs descendants)
						if (verifie_inclusions_groupe($groupe, $id_ss_groupe) == FALSE) {
							 continue;
						}
				// ne pas afficher les groupes appartenant  l'ascendance du groupe en cours
						if (verifie_inclusions_groupe($id_ss_groupe, $groupe) == FALSE) {
							 continue;
						}
            $nom_ss_grpe = strtoupper(substr(trim($nom_ss_groupe), 0, 1));
            echo "\n<OPTION VALUE=\"$id_ss_groupe\" style='background-color: $couleur_claire;'> $nom_ss_groupe</OPTION>\r\n";
      }

      echo "</SELECT>\r\n";
			
			echo "<input type=\"submit\" name=\"add_ss_groupe\" value=\""._T('accesgroupes:ajouter')."\"  CLASS='fondo'/>";
fin_cadre_couleur();
   } // fin limitation admin restreint
			echo "<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 WIDTH='100%' class='arial2' style='border: 1px solid #aaaaaa;'>\n";
      echo "<tr><th colspan='3'>"._T('accesgroupes:ss_groupes_groupe')."</th></tr>";
			$sql102 = "SELECT $Tjpk_groupes_auteurs.id_ss_groupe, $Tjpk_groupes_auteurs.dde_acces, $Tjpk_groupes.nom 
								 FROM $Tjpk_groupes_auteurs, $Tjpk_groupes
								 WHERE $Tjpk_groupes_auteurs.id_groupe = $groupe 
								 AND $Tjpk_groupes.actif = 1 
								 AND $Tjpk_groupes_auteurs.id_ss_groupe = $Tjpk_groupes.id_groupe 
								 ORDER BY $Tjpk_groupes.nom";
			$result102 = spip_query($sql102);
      while ($row = spip_fetch_array($result102)){
      			 $id_ec = $row['id_ss_groupe'];
      			 $nom_ec = $row['nom'];
      			 echo "<tr style='background-color: #eeeeee;'>";
             echo "<td class='verdana11' style='border-top: 1px solid #cccccc; width: 14px; vertical-align:top;'>";
						 echo "<img src='img_pack/groupe-12.png' alt='|_' style='vertical-align:top;'></td>";
             echo "<td style='border-top: 1px solid #cccccc;'><a href=\"$PHP_SELF?groupe=".$id_ec."\">".$nom_ec."</a><br />";
      			 echo affiche_descendance($id_ec, descendance_groupe($id_ec));
      			 echo "</td>";
             echo "<td style='border-top: 1px solid #cccccc; text-align : right; padding-right: 20px;'>";
		    if ($id_util_restreint == 0 OR ($id_util_restreint != 0 AND est_proprio($groupe) == TRUE)) {
						 echo "<a href=\"".$PHP_SELF."?del_ss_groupe=".$row['id_ss_groupe']."&groupe=".$groupe."\">"._T('accesgroupes:retirer_groupe')."&nbsp;". http_img_pack('croix-rouge.gif', "X", "width='7' height='7' border='0' align='middle'")."</a>";
             echo $row['dde_acces'] == 1 ? "&nbsp;|&nbsp;<a href=\"".$PHP_SELF."?mod_ss_groupe=".$row['id_ss_groupe']."&groupe=".$groupe."\">"._T('accesgroupes:accepter')."</a>" : "";
				}
				else {
						 echo "&nbsp;";
				}					 
						 echo "</td>";
             echo "</tr>";
      }
      echo "</table>";
fin_cadre_trait_couleur();

// dbut des statuts			
      echo "<br />";
debut_cadre_trait_couleur("statuts-24.png", false, "", _T('accesgroupes:statuts')._T('accesgroupes:du_groupe'));
			$Tstatuts = array("0minirezo" => "Administrateurs", "1comite" => "R&eacute;dacteurs", "6forum" => "Visiteurs");
   if ($id_util_restreint == 0 OR ($id_util_restreint != 0 AND est_proprio($groupe) == TRUE)) {
debut_cadre_couleur();
			echo _T('accesgroupes:ajouter_statut');
      echo "\r\n<SELECT NAME='sp_statut' SIZE='1' STYLE='width:150px;' CLASS='fondl'>\r\n";
			$sql105 = "SELECT sp_statut FROM $Tjpk_groupes_auteurs WHERE id_groupe = $groupe AND sp_statut != '' GROUP BY sp_statut";
			$result105 = spip_query($sql105);
			while ($row = spip_fetch_array($result105)) {
						$Tresult105[] = $row['sp_statut'];
			}
      echo "\n<OPTION VALUE=\"x\"> </OPTION>\r\n";
      foreach ($Tstatuts as $statut_ec => $nom_stat) {
							if (!in_array($statut_ec, $Tresult105)) {
  							 echo "\n<OPTION VALUE=\"$statut_ec\" style='background-color: $couleur_claire;'> $nom_stat</OPTION>\r\n";
							}
      }
      echo "</SELECT>\r\n";
			echo "<input type=\"submit\" name=\"add_statut\" value=\""._T('accesgroupes:ajouter')."\"  CLASS='fondo'/>";
fin_cadre_couleur();
   } // fin limitation admin restreint
      $sql104 = "SELECT $Tjpk_groupes_auteurs.sp_statut, $Tjpk_groupes_auteurs.dde_acces 
      				 FROM $Tjpk_groupes_auteurs, $Tjpk_groupes
      				 WHERE $Tjpk_groupes_auteurs.id_groupe = $groupe 
      				 AND $Tjpk_groupes.actif = 1 
      				 AND $Tjpk_groupes.id_groupe = $Tjpk_groupes_auteurs.id_groupe
      				 AND $Tjpk_groupes_auteurs.sp_statut != ''
      				 GROUP BY $Tjpk_groupes_auteurs.sp_statut";
      $result104 = spip_query($sql104);
      
      echo "<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 WIDTH='100%' class='arial2' style='border: 1px solid #aaaaaa;'>\n";
      echo "<tr><th colspan=\"3\">"._T('accesgroupes:statut_groupe')."</th></tr>";
      while ($row = spip_fetch_array($result104)) {
      			 $statut_ec = $row['sp_statut'];
      			 $nom_statut = $Tstatuts[$statut_ec];
  					 $statut_ec == '0minirezo' ?  $ico_statut = 'admin-12.gif' : ($statut_ec == '1comite' ? $ico_statut = 'redac-12.gif' : $ico_statut = 'visit-12.gif');
						 
      			 echo "<tr style='background-color: #eeeeee;'>";
             echo "<td class='verdana11' style='border-top: 1px solid #cccccc; width: 14px; vertical-align:top;'>";
						 echo "<img src='img_pack/".$ico_statut."' alt='|_' style='vertical-align:top;'></td>";
						 echo "<td style='border-top: 1px solid #cccccc;'>".$nom_statut."</td>";			 
             echo "<td style='border-top: 1px solid #cccccc; text-align : right; padding-right: 20px;'>";
			 if ($id_util_restreint == 0 OR ($id_util_restreint != 0 AND est_proprio($groupe) == TRUE)) {
						 echo "<a href=\"".$PHP_SELF."?del_statut=".$statut_ec."&groupe=".$groupe."\">"._T('accesgroupes:retirer_statut')."&nbsp;".http_img_pack('croix-rouge.gif', "X", "width='7' height='7' border='0' align='middle'")."</a>";
             echo ($row['dde_acces']== 1) ? "&nbsp;|&nbsp;<a href=\"".$PHP_SELF."?mod_statut=".$statut_ec."&groupe=".$groupe."\">"._T('accesgroupes:accepter')."</a>" : "";
			 }
			 else {
			 			echo "&nbsp;";
			 }
						 echo "</td>";
             echo "</tr>";
      }
      echo "</table>";
fin_cadre_trait_couleur();

// fin modif clem			

	 		echo "</form>";


// DEB RECUP DE rubriques_edit.php3
      echo "<br />";
debut_cadre_trait_couleur("rubrique-24.gif", false, "", _T('accesgroupes:rubriques_autorisees'));
      echo _T('accesgroupes:rubriques_autorisees_info');
      echo "<form action=\"$PHP_SELF\" name=\"frm_rubrique\" method=\"post\">\n";
      echo "<SELECT NAME='id_parent' style='background-color:#ffffff; font-size:90%; font-face:verdana,arial,helvetica,sans-serif; max-height: 24px;' class='forml' SIZE='1'>\n";
      if ($connect_toutes_rubriques) {
        echo "<OPTION".mySel("0",$id_parent). http_style_background('racine-site-12.gif',  "$spip_lang_left no-repeat; background-color:$couleur_foncee; padding-$spip_lang_left: 16px; font-weight:bold; color:white") .'>'._T('info_racine_site')."\n";
      } 
      else {
					 $Trub_autorise = cree_Trub_admin();
					 if (count($Trub_autorise) > 0) {
    					 enfant(0);
					 }
					 else {
					 			echo "<OPTION".mySel("0",$id_parent).">"._T('info_non_deplacer')."\n";
					 }
      }
      
      if (lire_meta('multi_rubriques') == 'oui') echo " [".traduire_nom_langue(lire_meta('langue_site'))."]";
      
      // si le parent ne fait pas partie des rubriques restreintes, modif impossible
      if (acces_rubrique($id_parent)) {
          enfant(0);
      }
      echo "</SELECT>\n";


      // FIN RECUP DE rubriques_edit.php3
      echo "<input type=\"submit\" name=\"add_rub\" value=\""._T('accesgroupes:autoriser')."\"  CLASS='fondo'/>\n";
      echo "<input type=\"hidden\" name=\"groupe\" value=\"$groupe\" />\n";
      echo "</form>\n";
      $sql_rub = "
      SELECT $Tspip_rubriques.*
        FROM $Tjpk_groupes_acces, $Tspip_rubriques
        WHERE $Tspip_rubriques.id_rubrique = $Tjpk_groupes_acces.id_rubrique AND
              $Tjpk_groupes_acces.id_groupe = \"$groupe\"";
      $result_rub = spip_query($sql_rub);
      debug($result_rub);
      echo "<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 WIDTH='100%' class='arial2' style='border: 1px solid #aaaaaa;'>\n";
      echo "<tr><th colspan='3'>"._T('accesgroupes:autoriser_info')."</tr>";
      while ($row=spip_fetch_array($result_rub)){
      			echo "<tr style='background-color: #eeeeee;'>";
						echo "<td class='verdana11' style='border-top: 1px solid #cccccc; width: 14px; vertical-align:top;'>";
						echo "<img src='img_pack/rubrique-12.gif' alt='|_' style='vertical-align:top;'></td>";
						echo "<td style='border-top: 1px solid #cccccc;'><a href=\"naviguer.php3?id_rubrique=".$row['id_rubrique']."\">".typo($row['titre'])."</a></td>";
						echo "<td style='border-top: 1px solid #cccccc; text-align : right; padding-right: 20px;'>";
			 if ($id_util_restreint == 0 OR ($id_util_restreint != 0 AND est_proprio_acces($row['id_rubrique']) == TRUE)) {
						echo "<a href=".$PHP_SELF."?del_rub=".$row['id_rubrique']."&groupe=$groupe>"._T('supprimer')."&nbsp;". http_img_pack('croix-rouge.gif', "X", "width='7' height='7' border='0' align='middle'") ."</a>";
			 }
			 else{
			 			echo "&nbsp;";
			 }
						echo "</td></tr>";
      }
      echo "</table>";

fin_cadre_trait_couleur();
}

// liste des groupes ayant accs  la rubrique courante...
$sql_rub_grp = "SELECT $Tjpk_groupes.*
  					 	  FROM $Tjpk_groupes_acces, $Tjpk_groupes
  							WHERE $Tjpk_groupes_acces.id_groupe = $Tjpk_groupes.id_groupe 
								AND $Tjpk_groupes_acces.id_rubrique = \"$id_parent\" 
								AND $Tjpk_groupes_acces.id_groupe <> $groupe";
$result_rub_grp = spip_query($sql_rub_grp);
if ($id_parent > 0 && spip_num_rows($result_rub_grp) > 0 ){
    debut_cadre_relief("mot-cle-24.gif");
    echo gros_titre(_T('accesgroupes:acces_rubrique_par'));
    echo "<ul>";
    while ($row=spip_fetch_array($result_rub_grp)){
    			echo "<li>".typo($row['nom'])."</li>";
    }
    echo "</ul>";
    fin_cadre_relief();
}
fin_page();
?>