<?php
// DEB - Acces groupes
/*
Permet d'interroger les tables jpk_
utilises dans la gestion des droits d'accs

N'oubliez pas de copier le fichier inc-connect_jpk.php3 dans /ecrire
et de modifier les infos de connection  la base de donnes
*/

// modifs clem pour utilisation d'un prfixe au noms de tables SPIP et/ou _jpk
include_once("inc_config-jpk.php3");

//fin modif


// ==== TABLES JPK ====
$jpk_groupes = array(
     "id_groupe" => "bigint(21) auto_increment",
     "nom" => "varchar(30)",
     "description" => "varchar(250)",
     "actif" => "smallint(1)",
		 "proprio" => "bigint(21) NOT NULL DEFAULT '0'"
);
$jpk_groupes_key = array(
  "PRIMARY KEY"  => "id_groupe",
  "KEY id_groupe" => "id_groupe"
  
);

$jpk_groupes_auteurs = array(
    "id_groupe" => "bigint(21) NOT NULL DEFAULT '0'",
    "id_auteur" => "bigint(21) NOT NULL DEFAULT '0'",
		"id_ss_groupe" => "bigint(21) NOT NULL DEFAULT '0'",
		"spip_statut" => "varchar(255) NOT NULL DEFAULT '0'",
    "dde_acces" => "smallint(1)",
		"proprio" => "bigint(21) NOT NULL DEFAULT '0'"
);
$jpk_groupes_auteurs_key = array(
    "KEY id_groupe"  => "id_groupe",
    "KEY id_auteur" => "id_auteur",
		"KEY id_ss_groupe" => "id_ss_groupe",
		"KEY statut" => "statut"
);

$jpk_groupes_acces = array(
    "id_groupe" => "bigint(21) NOT NULL default '0'",
    "id_rubrique" => "bigint(21) NOT NULL default '0'",
    "id_article" => "bigint(21) default NULL",
    "dtdb" => "date default NULL",
    "dtfn" => "date default NULL",
		"proprio" => "bigint(21) NOT NULL DEFAULT '0'"
);
$jpk_groupes_acces_key = array(
    "KEY id_groupe"  => "id_groupe",
    "KEY id_rubrique"  => "id_rubrique",
    "KEY id_auteur" => "id_auteur"
);

$tables_jpk['jpk_groupes'] =
    array('field' => &$jpk_groupes, 'key' => &$jpk_groupes_key);
    
$tables_jpk['jpk_groupes_auteurs'] =
    array('field' => &$jpk_groupes_auteurs, 'key' => &$jpk_groupes_auteurs_key);    

$tables_jpk['jpk_groupes_acces'] =
    array('field' => &$jpk_groupes_acces, 'key' => &$jpk_groupes_acces_key);

$GLOBALS['tables_des_serveurs_sql']['JPK']=&$tables_jpk;


// Fonction de contrle des accs
function IdAut($aut){
      // modifs clem pour utilisation d'un prfixe dans les noms de tables
      		global $Tspip_rubriques, $Tspip_auteurs, $Tspip_auteurs_rubriques, $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes;
      
      // trouve l'id_auteur  partir du login
      $sql = "SELECT id_auteur, statut FROM $Tspip_auteurs WHERE login='" .addslashes($aut) ."' LIMIT 1";
      $result = spip_query($sql);
      if ($result){
         if ($row = spip_fetch_array($result)){
            $aut = $row['id_auteur'];
         }
      }
      return $aut;
}

function RubPrive($rub){
      // vrifie si la rubrique courante est prive
      
      // modifs clem pour utilisation d'un prfixe dans les noms de tables
      		global $Tspip_rubriques, $Tspip_auteurs, $Tspip_auteurs_rubriques, $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes;
      
      $sql = "SELECT count(*) FROM $Tjpk_groupes_acces WHERE id_rubrique = $rub";
      $result = spip_query($sql);
      if ($row = spip_fetch_array($result)){
      	 $prive = $row['0'];
      }
      if ($prive > 0){
         return true;
      }else{
         return false;
      }
}
function GrpAcces($aut,$rub){
      // modifs clem pour utilisation d'un prfixe dans les noms de tables
      		global $Tspip_rubriques, $Tspip_auteurs, $Tspip_auteurs_rubriques, $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes;
      
      $acces = 0;
		// les admins restreints ont accs sans limitation  leur rubrique
		  $sql507 = "SELECT COUNT(*) AS est_admin FROM $Tspip_auteurs_rubriques WHERE id_auteur = $aut AND id_rubrique = $rub LIMIT 1";
			$result507 = spip_query($sql507);
			$row507 = spip_fetch_array($result507);
			if ($row507['est_admin'] > 0) {
				 return TRUE;
			}
			
      $sql = "SELECT count(*) AS NbAcces 
					 	  FROM $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes
        			WHERE $Tjpk_groupes_acces.id_groupe = $Tjpk_groupes_auteurs.id_groupe 
							AND $Tjpk_groupes_auteurs.id_groupe = $Tjpk_groupes.id_groupe 
              AND $Tjpk_groupes_auteurs.id_auteur = $aut  
              AND $Tjpk_groupes_auteurs.dde_acces = 0 
              AND $Tjpk_groupes_acces.id_rubrique = $rub 
              AND $Tjpk_groupes.actif = 1";
      $result = spip_query($sql);
      if ($row = spip_fetch_array($result)){
         $acces = $row['NbAcces'];
      }
      if ($acces > 0){
         return true; // accs autoris
      }
			else {
         // modif clem : si pas d'accs direct pour l'auteur => test si les groupes auxquels il appartient ont un droit d'acces
  				 $sql201 = "SELECT id_groupe FROM $Tjpk_groupes_auteurs WHERE id_auteur = $aut";
  				 $result201 = spip_query($sql201);
  				 while ($row = spip_fetch_array($result201)) {
  							 if (ssGrpAcces($row['id_groupe'], $rub) == TRUE) {
								 		return TRUE;
								 }
  				 }
  			// modif clem : si pas d'accs direct ou par groupes => test des groupes dans lesquels l'utilisateur est inclu par son statut
					 $sql202 = "SELECT statut FROM $Tspip_auteurs WHERE id_auteur = $aut LIMIT 1";
           $result202 = spip_query($sql202);
           if ($result202){
              if ($row = spip_fetch_array($result202)){
    					   $sp_statut = $row['statut'];
              }
    			 }
					 $sql204 = "SELECT id_groupe FROM $Tjpk_groupes_auteurs WHERE sp_statut = '$sp_statut'";					 
  				 $result204 = spip_query($sql204);
  				 while ($row = spip_fetch_array($result204)) {
  							 if (ssGrpAcces($row['id_groupe'], $rub) == TRUE) {
  									  return TRUE;
  								 }
  				 }
 					 return false;
      }
}

// modif clem pour test des accs par ss-groupe, rcursivement dans toute l'ascendance du groupe test
function ssGrpAcces($id_grpe, $rub) {
      	 global $Tspip_rubriques, $Tspip_auteurs, $Tspip_auteurs_rubriques, $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes;
				 
				 $sql202 = "SELECT COUNT(*) AS NbAcces FROM $Tjpk_groupes_acces WHERE id_groupe = $id_grpe AND id_rubrique = $rub";
				 $result202 = spip_query($sql202);
				 if ($row = spip_fetch_array($result202)) {
				 		if ($row['NbAcces'] > 0) {
							 return TRUE;
						}
  				  else {
  				 		// test des groupes de l'ascendance du groupe test
								 $sql203 = "SELECT id_groupe FROM $Tjpk_groupes_auteurs WHERE id_ss_groupe = $id_grpe";
  							 $result203 = spip_query($sql203);
  							 while ($row = spip_fetch_array($result203)) {
  										 $id_at = $row['id_groupe'];
  										 if (ssGrpAcces($id_at, $rub) == TRUE) {
  											  return TRUE;
  										 }
  							 }
  				  }
				 }
				 return FALSE;
}


function verif_acces($rub){
      // modifs clem pour utilisation d'un prfixe dans les noms de tables
      		global $Tspip_rubriques, $Tspip_auteurs, $Tspip_auteurs_rubriques, $Tjpk_groupes_acces, $Tjpk_groupes_auteurs, $Tjpk_groupes;
      
      $aut = $GLOBALS['auteur_session']['login'];
      // vrifie si la rubrique courante est prive
      do{ // boucle tant que la rubrique n'est pas la racine du site ou le retour est vide
         if (RubPrive($rub)){
            if ($aut <> ""){
               $aut=IdAut($aut); // cherche l'id_auteur
               if (GrpAcces($aut,$rub)){
                 $retour = 3; //"Bienvenue";
               }else{
                 $retour = 2; //"Accs non autoris";
               }
            }else{
               $retour = 1; //"non connect";
            }
         }else{
            $retour = 0; // Accs libre - vrifier la rubrique parente
         }
         $sql = "SELECT * FROM $Tspip_rubriques WHERE id_rubrique=$rub"; // recherche la rubrique parente
         $result = spip_query($sql);
         if ($row=spip_fetch_array($result)){
            $rub= $row['id_parent'];
         }
      }while ($rub > 0 && $retour == 0 );
      
      return $retour;
}


function verif_acces_texte($txt,$rub){
      // test de cration de filtre pour limiter les accs...
      switch(verif_acces($rub)){
        case 0: // Accs libre
          $txt = "$txt"; 
          break;
        case 1: //"non connect";
          $txt = _T("accesgroupes:non_connecte");  
          break;
        case 2: //"Accs non autoris";
          $txt = _T("accesgroupes:bloque_rubrique"); 
          break;    
        case 3: //"Bienvenue";
          $txt = "$txt"; 
          break;    
        default: //"non connect";
          $txt = _T("accesgroupes:non_connecte"); 
      }
      return $txt;
}

// FIN - Acces groupes
?>